<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="/images/favicon.ico">

    <title>Agent Console</title>

    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@100;300;400;500&display=swap" rel="stylesheet">

    <!-- Bootstrap core CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <link rel="stylesheet" href="/stylesheets/agents.css" type="text/css">

    <!-- Custom styles for this template -->
    <link href="/stylesheets/agents.css" rel="stylesheet">
    <!-- Custom styles for this template -->
    <link href="/stylesheets/conversations.css" rel="stylesheet">
    <!-- <script src="/socket.io/socket.io.js"></script> -->

</head>

<body >
    <!-- Header Start -->
<div id="app">
    <div class="header">
        <div class="header-wrapper">
            <div class="header-title">Agent Console</div>
            <div class="header-profile">
                <div>
                    <div >{{first_name}} {{last_name}}</div>
                    <div>{{user_role}}</div>
                </div>
                <div class="action">
                    <div class="profile" data-toggle="dropdown" onclick="menuToggle();">{{nameAbb}}</div>
                    <div class="menu">  
                        <ul>
                            <li @click="convoPage()">Conversations</li>
                            <li @click="agentPage()">Account Management</li>
                        </ul>
                    </div>
                </div>

                <!-- <div class="dropdown">
                    <div class="dropdown-toggle dropdown-menu-left" data-toggle="dropdown">JA</div>
                    <ul class="dropdown-menu">
                        <li><a href="#">Edit profile</a></li>
                        <li><a href="#">Account Management</a></li>
                    </ul>
                </div> -->
            </div>
        </div>
    </div>
    <!-- Header End -->

    <!-- Chat Container Start -->
    <div class="chat-container chat-fadeIn" >
        <!-- Left Section -->
        <div class="chat-list">
            <div class="chat-search">
                <div>Conversations</div>
                <div>
                    <input type="text" />
                    <i class="fa fa-search"></i>
                </div>
            </div>
            <div class="user-section">
                <div class="sm-title">Live Conversations</div>
                <div class="user-list">
                    <ul>
                        <!-- <li @click="updateSelected(item)" v-for="item in conversations_list" :id=item.convo_id > -->
                        <li>

                            <!-- Users -->
                            <!-- <div v-if="item.filter == queue"> -->
                                <div>

                                
                                <!-- <div>{{ item.initials }}</div> -->
                                <div>MR</div>

                                <!-- <div>GM</div> -->

                                <div>
                                    <!-- <div>{{ item.first_name }}</div>
                                    <div> {{item.timestamp}}</div>
                                    <div> {{item.location}}</div> -->

                                    <div>MOHAMMED RAYAN</div>
                                    <div> 20 MAY 2021 </div>
                                    <div> BENGALURU ,IN</div>
                                    <!-- <div>{{ item.date }} {{ item.time }}</div>
                                    <div>{{ item.location }}</div> -->
                                </div>
                                <img class="info-convoList" @click="chatHistory" class="info-requestImg" src="/assets/images/info.png" />
                            </div>


                            <!-- End -->
                        </li>
                    </ul>
                </div>
            </div>
            <div class="user-section no-border">
                <div class="sm-title">New Requests</div>
                <div class="user-list">
                    <ul>
                        <li>

                            <!-- <div v-for="(item,i) in messages_requests" :id=item.convo_id v-if="item.filter == queue "> -->
                                <div>

                                <!-- <div>{{ item.initials }}</div> -->
                                <div>MR</div>

                                <div>
                                    <!-- <div>{{ item.first_name }}</div>
                                    <div> {{item.timestamp}}</div>
                                    <div> {{item.location}}</div> -->
                                    <div>MOHAMMED RAYAN</div>
                                    <div>20 MAY 2021</div>
                                    <div>BENGALURU , IN</div>
                                    <!-- <div>{{ item.date }} {{ item.time }}</div>
                                    <div>{{ item.location }}</div> -->

                                </div>
                                <button @click="acceptChat($event,i,item)">Accept</button>
                                <img @click="chatHistory" class="info-requestImg" src="/assets/images/info.png" />
                                
                            </div>
                            <!-- End -->
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <!-- End left Section -->
        <div v-if="agentConsole" class="chat-panel dashboard-console">
            <p>Welcome to Avaamo Agent Console</p>
            <img src="/assets/images/welcome-icon.svg" />
            <p>Avaamo agent console is a comprehensive chat solution that makes it easy for you to support customers</p>
        </div>
        <!-- Right Section -->
        <!-- RAYAN CODE -->
                <!-- <div class="info-container" id="info-contan"> -->
                    <div class="info-contan" id="info-contan">
                        <div class="info-modal">
                            <div class="info-header">
                                <h3>Chat History</h3>
                            </div>
                            <div class="info-body" v-for="msgs in testHistory">
                                
                                <div v-if="msgs.name =='user'">
                                        <img class="user-chatIcon" src="/assets/images/avatar-developer.png"/>
                                        <div class="user-chat">
                                            <p>{{msgs.message}}</p>
                                        </div>
                                        
                                 </div>
                                
                                
                                <div v-if="msgs.name=='bot'">
                                        <img class="bot-chatIcon" src="/assets/images/support.png"/>
                                        <div class="bot-chat">
                                            <p>{{msgs.message}}</p>
                                        </div>
                                </div>                    
                            </div>
                            <div class="info-footer">
                                <button @click="cancelInfo()">Cancel</button> 
                             </div>
                        </div>
                    </div>
        <div v-if="!agentConsole" class="chat-panel ">


            <!-- Top section -->
            <div class="top-section">
                <div>
                    <div class="avatar">
                        <img src="/assets/images/avatar-developer.png" />

                    </div>       
                    <div class="user-info" >
                        <div>{{chatHeader.first_name}}</div>
                        <div>{{chatHeader.timestamp}}</div>
                    </div>
                </div>
                <div>
                    <button @click="closeButton">Close</button>
                    <i class="fa fa-ellipsis-v"></i>
                </div>
            </div>
            <!-- End Top Section -->



            <!-- Middle Section -->
            <div class="middle-section">
               
                <div v-for="msgs in messages">
                    <div v-if="msgs.type=='Guest'" class="chat-basic chat-type-1">
                        <div>
                            <img width="38" src="/assets/images/support.png" />
                        </div>
                        <div>
                            <div class="chat-info">
                                <div>{{ msgs.message}}</div>
                                
                            </div>
                            <div class="chat-time">{{msgs.timestamp}}</div>
                        </div>
                    </div>

                    <!-- Chat type 2 Start-->
                    <div v-if="msgs.type=='sys'" class="chat-basic chat-type-1 chat-type-2">
                        <div>
                            <img width="38" src="/assets/images/support.png" />
                        </div>
                        <div>
                            <div class="chat-info">
                                <div>{{msgs.msg}}</div>
                            </div>
                            <div class="chat-time">8:10am</div>
                        </div>
                    </div>
                    <!-- End Chat type 2 -->

                    <!-- Chat type 3 Start-->
                    <div v-if="msgs.type=='Agent'" class="chat-basic chat-type-5">
                        <!-- <div>RI</div> -->
                        <div>
                            <div class="chat-info">
                                <div>{{msgs.message}}</div>
                            </div>
                            <div class="chat-right-time">{{msgs.timestamp}}</div>
                        </div>
                    </div>
                    <!-- End Chat type 3 -->

                    <!-- Chat type 4 Start-->
                    <!-- <div v-if = "msgs.type=='agent'" class="chat-basic chat-type-4">
                    <div>
                        <img width="38" src="/assets/images/connect.png" />
                    </div>
                    <div>
                        <div class="chat-info">
                            <div>HR case CASE - 0133413</div>
                        </div>
                        <div class="chat-time">System Message : 8:11am</div>
                    </div>
                </div> -->
                    <!-- End Chat type 4 -->

                </div>
 </div>
            <!-- End Middle Section -->

            <!-- Attach Section -->
            <div class="attach-section">
                <button class="files">Attach Files</button>
                <button class="escalate" data-toggle="modal" data-target="#myModal">Escalate</button>
            </div>
            <!-- End Attach Section -->


            <!-- Bottom Section -->
            <div class="bottom-section">
                <div class="attach-menu">

                    <img src="/assets/images/menu.png" />


                </div>
                <div>
                    <input v-model="newMessage" type="text" placeholder="Type in a message" />
                </div>
                <div>
                    <img v-on:click="send" src="/assets/images/send.png" />

                </div>
            </div>
            <!-- End Bottom Section -->
        </div>
        <!-- End Right Section -->
    </div>
    <!-- Chat Container End -->

    <!-- Modal popup -->
    <div class="modal modal-popup fade" id="myModal" role="dialog">
        <div class="modal-dialog">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-body">
                    <div class="modal-btn">
                        <div>Escalate</div>
                        <div>
                            <button data-dismiss="modal">Close</button>
                            <button class="active">Proceed</button>
                        </div>
                    </div>
                    <div class="modal-txt">
                        <div>Do you want to escalate the issue to your Senior Official/ Manager</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End -->
</div>
</body>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/3.1.1/socket.io.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js"></script>

<script>

function menuToggle(){
        const toggleMenu = document.querySelector('.menu');
        toggleMenu.classList.toggle('active');
    }

    console.log('checkSocket val:',window.location.hostname);
    var socket = io.connect(`wss://${window.location.hostname}`, { transports: ['websocket'] });

    // socket.emit('message', { 'data': 'hello there' });
    //  test = new Vue({
    //     el:'#test',
    //     data:{
    //         tempMsg :[{'msg':'What can I help you with today?','type':'sys1'},{'msg':'What can I help you with tomorrow?','type':'sys'},{'msg':'Hi, Hello','type':'user'},{'msg':'Agent here','type':'agent'}]
    //     }
    // })
    let vue = new Vue({
        el: '#app',
        data: {
          
             tempMsg:[],
             newMessage: null,
            messages: [],
            conversations_list: [],
            messages_requests: [],
            typing: false,
            username: null,
            agentConsole: true,
            info: [],
            connections: 0,
            newRequests: [],
            selectedChat: {},
            chatHeader:{},
            account_id : localStorage.getItem('accountId'),
            user_role: localStorage.getItem('roles'),
             last_name:localStorage.getItem('lastName'),
             first_name:localStorage.getItem('firstName'),
             queue:localStorage.getItem('queue'),
             nameAbb:null,
             testHistory:[
                        {name:"user", message:"hello" , id:123},
                        {name:"bot", message:"Hi ,How can i help you" , id:1234},
                        {name:"user", message:"Iam stuck with a error that whateva i order it gets renderd to menu page" , id:123},
                        {name:"bot", message:"Let me check that ,hold for a sec" , id:1234},
                        {name:"user", message:"Sure.." , id:123},
                        {name:"bot", message:"I have recorded your error,restart and try again please" , id:1234},
                        {name:"user", message:"Wt if i get an error again" , id:123},
                        {name:"bot", message:"iam sure you wudnt.if you do iam here to help" , id:1234},
                        {name:"user", message:"thank you" , id:123},
                          ]
             
            },
        created() {
            // window.onbeforeunload = () => {
            //     socket.emit('leave', this.username);
            // }

            socket.on('message', (data) => {
                console.log("Message from chatbot", data);
                let time  = new Date(data.timestamp).toUTCString();
                        let Hour = new Date(time).getUTCHours();
                        let Min = new Date(time).getUTCMinutes();
                this.messages.push({
                    message: data.message,
                    account: data.account,
                    conversation_uuid: data.conversation_uuid,
                    liveagentToken: data.liveagentToken,
                    timestamp:Hour+":"+Min,
                    type:"Guest"
                });


                socket.on('disconnected_chat',(data)=> {
                    console.log("End Chat",data);
                this.conversations_list.forEach((element,i) => {
                    if(element.convo_id == data.conversationId){
                        this.conversations_list.splice(i,1);
                    }
                });
            });
 });

            socket.on('chat_request_accept', (data) => {
                console.log("Chat Request Accepted", data);

                for (let i = 0; i < this.messages_requests.length; i++) {
                    console.log('test',this.messages_requests[i].convo_id,'\n',data.convo_id);
                    if (this.messages_requests[i].convo_id == data.convo_id) {
                        let value = this.messages_requests.splice(i, 1);
                        console.log("SPLICED ITEM", value);
                        this.conversations_list.push(value[0]);
                        console.log('checkArray-->>',this.conversations_list);
                    }
                }
            });

            socket.on('chat_request', (data) => {
                console.log("Chat Request Data", data);
                this.messages_requests.push({
                    account: data.account,
                    conversation_uuid: data.conversation_uuid,
                    liveagentToken: data.liveagentToken,
                    first_name: data.first_name,
                    last_name: data.last_name,
                    convo_id: data.conversation_id,
                    timestamp : new Date(data.timestamp).toUTCString().split(',')[1],
                    filter: data.filter,
                    initials: data.first_name.slice(0,1) + (data.last_name ? data.last_name.slice(0,1): '')


                });
                console.log("Chat Request messages_requests", this.messages_requests);
            });

            socket.on('connections', (data) => {
                this.connections = data;
            });
        },


        watch: {
            newMessage(value) {
                value ? socket.emit('typing', this.username) : socket.emit('stopTyping')
            }
        },
        methods: {
            myFunction(){
                this.user_role= localStorage.getItem('roles');
        this.first_name=localStorage.getItem('firstName');
        this.last_name=localStorage.getItem('lastName');  
            console.log('fName1', this.first_name);
            },
            updateSelected(selectedItem) {
                console.log("selectedItem", selectedItem);
                this.agentConsole = false;
                this.chatHeader = selectedItem;
                console.log("convoId", this.chatHeader.convo_id);
                fetch(`/api/conversations/${this.chatHeader.convo_id}/messages`, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then((res) => {
                   
                    return res.json();
                }).then(data => {
                    console.log("Get list of msgs", data);
                    // console.log("Get list of msgs", data[0].message);
                    if(data.length>0){

                    
                    for(i=0;i<data[0].message.length;i++){
                        let time  = new Date(data[0].message[i].createdAt).toUTCString();
                        let Hour = new Date(time).getUTCHours();
                        let Min = new Date(time).getUTCMinutes();
                        this.messages.push({
                    message: data[0].message[i].text,
                    timestamp:Hour+":"+Min,
                    type:data[0].message[i].from
                });
                    }
                }
                    //this.messages.push(data)
                });               
            },
            // closeButton() {
            //     this.agentConsole = true;
            // },
            send: function () {
                console.log('checkConvoID',this.chatHeader.convo_id,'\n',this.newMessage);
                if(this.message !== ''){
                this.messages.push({
                    message: this.newMessage,
                    timestamp: new Date().getHours()+':'+new Date().getMinutes(),
                    type:"Agent"
                })
                let payload = { "message":this.newMessage};
                
                // fetch(`https://api.allorigins.win/get?url=${encodeURIComponent(`/api/conversations/${this.chatHeader.convo_id}/postMessage`)}`, {
                    fetch(`/api/conversations/${this.chatHeader.convo_id}/postMessage`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'Access-Token': localStorage.getItem('token')
                    },
                    body:JSON.stringify(payload)
                }).then((res) => {
                    //message push in the list 1
                    socket.emit('chat_message', {
                        message: this.newMessage,
                        user: this.username,
                        conversation_uuid: this.conversation_uuid,
                        conversation_id: this.conversation_id
                    });
               this.newMessage = '';

                    return res.json();
                })
            }
            },

            acceptChat: function (e, i, item) {
                // alert(e);
                console.log("i", i, "\nitem:", item);
                this.conversations_list.push(item);
                this.messages_requests.splice(i, 1);
                // console.log(e)
                // console.log(e.currentTarget)
                // console.log(e.target.parentElement);
                // console.log(e.target.parentElement.children);
                console.log(e.target.parentNode.id);
                console.log(e.target.parentNode.id);
                console.log(typeof e.target.parentNode.id)
                console.log('CheckLocalStorage',localStorage.getItem('token'));

                fetch(`/api/conversations/${e.target.parentNode.id}/acceptChat`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'Access-Token': localStorage.getItem('token')
                    }
                }).then((res) => {
                    //message push in the list 1
                    console.log('acceptChat==>', res);
                    return res.json();
                })
            },

            listOfChatRequest: function () {
                
                let self = this;
                fetch(`/api/conversations/${this.account_id}/list`, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then((res) => {
                    return res.json();
                }).then(data => {
                    
                    console.log("DATA========1++>>>>>>>", data);
                   
                    self.newRequests = data;
                });
            },
            newRequest(){
                
                //this.chatHeader.convo_id = "12345665";
                // this.chatHeader.convo_id = localStorage.getItem("convo");
                
                fetch(`/api/conversations/${this.account_id}/new`, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then((res) => {
                   
                    return res.json();
                }).then(data => {
                    if(data.length>0){
                    for(i=0;i<data.length;i++){
                    this.messages_requests.push({
                    account: data[i].account,
                    conversation_uuid: data[i].conversation_uuid,
                    liveagentToken: data[i].liveagentToken,
                    first_name: JSON.parse(data[i].guest).first_name,
                    last_name: JSON.parse(data[i].guest).last_name,
                    convo_id: data[i]._id,
                    timestamp : new Date(data[i].timeCreatedAt).toUTCString().split(',')[1],
                    filter:data[i].filter,
                    initials:JSON.parse(data[i].guest).first_name.slice(0,1)+(JSON.parse(data[i].guest).last_name ? JSON.parse(data[i].guest).last_name.slice(0,1): '')
                });                    
            }
        }
                });
            },
            liveRequest(){
                let accountId =  localStorage.getItem('accountId');

               fetch(`/api/conversations/${this.account_id}/live`, {
                   method: 'GET',
                   headers: {
                       'Content-Type': 'application/json'
                   }
               }).then((res) => {
                   return res.json();
               }).then(data => {
                   // console.log("DATA========++>>>>>>>", data);
                   console.log("DATA========1++>>>>>>>", data);
                for(i=0;i<data.length;i++){

                this.f_name = JSON.parse(data[i].guest).first_name;
                   this.conversations_list.push({
                    account: data[i].account,
                    conversation_uuid: data[i].conversation_uuid,
                    liveagentToken: data[i].liveagentToken,
                    first_name: JSON.parse(data[i].guest).first_name,
                    last_name: JSON.parse(data[i].guest).last_name,
                    convo_id: data[i]._id,
                    timestamp : new Date(data[i].timeCreatedAt).toUTCString().split(',')[1],
                    filter:data[i].filter,
                    initials:JSON.parse(data[i].guest).first_name.slice(0,1)+(JSON.parse(data[i].guest).last_name ? JSON.parse(data[i].guest).last_name.slice(0,1): '')
                });
            }
                   // console.log("DATA========2++>>>>>>>", data[1]);
                   self.newRequests = data;
               });
           },

           closeButton: function () {
            this.agentConsole = true;
                fetch(`/api/conversations/${this.chatHeader.convo_id}/endChat`, {
                    method: 'PUT',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then((res) => {
                    //message push in the list 2
                    return res.json();
                }).then((data)=>{
                    console.log('End Chat-->',data);
                    this.conversations_list.forEach((element,i) => {
                        if(element.convo_id == data.conversationDetails._id){
                            this.conversations_list.splice(i,1);

                        }
                        
                    });
                    
                })
            },
            chatHistory:function(){
                console.log("FROM chatHISTORY");
                var historyModal = document.getElementById('info-contan');
                historyModal.style.display="block"
                // document.getElementById('info-contan').style.display="block";
            },
            cancelInfo:function(){
                var closeModal = document.getElementById('info-contan');
                closeModal.style.display="none";
                // document.getElementById('info-contan').style.display="none";
            },
       assignfunction(){
        vue.user_role= localStorage.getItem('roles');
        vue.first_name=localStorage.getItem('firstName');
        vue.last_name=localStorage.getItem('lastName');  
            console.log('fName1', vue.first_name);
        },
        convoPage:function(){
            
            window.location = "/users/conversations";
        },
        agentPage:function(){
            
            window.location = "/users/agents";
        }
    },
    mounted() { 

       // this.cats = JSON.parse(localStorage.getItem('cats'));
        //this.tempArray = JSON.parse(localStorage.getItem('firstName'));
        // vue.user_role= localStorage.getItem('roles');
        // vue.first_name=localStorage.getItem('firstName');
        // vue.last_name=localStorage.getItem('lastName');  
            // console.log('fName1', vue.first_name);
    },
        beforeMount() {
          //  this.listOfChatRequest(),
            this.newRequest(),
            this.liveRequest(),
            this.nameAbb = this.first_name.slice(0,1)+this.last_name.slice(0,1);
            console.log('checkName', this.first_name);
            //this.assignfunction()
             

        }
    });

</script>

</html>